$(function(){
  init();
});

let MasterNode = "-";

let appData = {
  master: "-",
  slaves: [],
  ips: [],
  slaves_selected: []
}

function init(){

  // css
  $("#nodelist").css({
    padding:'10px 0px'
  });

  $("#masternode").css({
    'font-weight': 'bold'
  });

  update_master_node();

  // init button
  $('#listmasters').on('click', function(e){

    $.ajax({
      url: '/api/nodelist',
      success: function(response){

        const l = response.trim().split('\n');

        let ll = [];

        $("#nodelist").empty();
        l.forEach(function(entry) {
          ll.push("<div class='master_nodes'>"+entry+"</div>");
        });
        $("#nodelist").empty().append(ll.join('\n'));

        $(".master_nodes").on('click',function(e){
          update_master_node($(this).html());
          $("#nodelist").empty();
          // go straight with ifconfig
          send_command('ifconfig', appData.slaves, parse_cmd_ifconfig_init);
        });

      }
    });

  });

  $('#testbutton2').on('click', function(e){
    send_command('state', appData.slaves_selected, parse_cmd_state);
  });

  // need a post request
  $('#testbutton3').on('click', function(e){

    // examples:
    //let cmd = "wget -qO- -o /dev/null 'http://localhost/parsedit.php?immediate&amp;TRIG'";
    //let cmd = "ifconfig";
    //let cmd = "wget -qO- -o /dev/null 'http://localhost/diagnostics.php'";
    //const cmd = "ifconfig";

    let path = "/sys/devices/soc0/elphel393-detect_sensors@0";
    let cmd = [
      'cd '+path,
      'cat port_mux0',
      'cat sensor00',
      'cat sensor01',
      'cat sensor02',
      'cat sensor03',
      'cat port_mux1',
      'cat sensor10',
      'cat sensor11',
      'cat sensor12',
      'cat sensor13',
      'cat port_mux2',
      'cat sensor20',
      'cat sensor21',
      'cat sensor22',
      'cat sensor23',
      'cat port_mux3',
      'cat sensor30',
      'cat sensor31',
      'cat sensor32',
      'cat sensor33'
    ].join(';');

    send_command(cmd, appData.slaves_selected,parse_cmd_testing);

  });

}

function parse_cmd_testing(res){

  $(res).find('response').each(function(){

    const name = $(this).find('node').text();
    let state = $(this).find('state').text();
    const xmlstate = $.parseXML(`<document>${state}</document>`);

    if ($(xmlstate).find("error").length!=0){
      console.log(name+" is not 10393");
      $("."+name).append(" <b style='color:DarkOrange;'>not 10393</b>");
    }else{
      let sensors = state.trim().split('\n');
      //console.log(sensors);
      for(let i=0;i<4;i++){
        let mux = sensors[5*i];
        console.log("port "+i+" mux is "+mux);
        if (mux==="none"){
          console.log("sensor is "+sensors[5*i+1]);
        }else{
          console.log("warning: mux is not 'none'");
        }
      }
    }

  });

}

function parse_cmd_state(res){

  let rtab = [
    '<table class="slave_table">',
    '  <tr>',
    '  <th>Slave</th>',
    '  <th>State</th>',
    '  </tr>'
  ];

  $(res).find('response').each(function(){
    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    rtab = rtab.concat([
      '<tr>',
      '  <td class="name">'+name+'</td>',
      '  <td class="state">'+state+'</td>',
      '</tr>',
    ]);
  });
  rtab.push('</table>');
  $("#nodelist").empty().append(rtab.join('\n'));
}

function parse_cmd_ifconfig_init(res){

  $(res).find('response').each(function(){

    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    const ip = get_ipaddr_from_ifconfig(state);

    update_slave_list(name);
    update_ip_list(ip);

    let html = [
      '<div class=\''+name+'\'>',
      '<input class=\'slave_checkbox\' type=\'checkbox\' checked />',
      '<label class=\'lbl_name\'>'+name+'</label>',
      '(<label class=\'lbl_ip\'>'+ip+'</label>)',
      '</div>'
    ].join('\n');
    $("#slavenodes").append(html);

  });

  $(".slave_checkbox").on("change",function(e){
    let checked = $(this).prop("checked");
    let name = $(this).parent().find("label").html();
    if (!checked) {
      appData.slaves_selected = appData.slaves_selected.filter(item => item!==name);
    }else{
      appData.slaves_selected.push(name);
    }
  });

}

function send_command(cmd,targets,callback){

    if (callback===undefined) {
      callback = function(res){
        console.log(res);
        //console.log($(res).find('document').html());
      }
    }

    let targets_str = "";
    if (Array.isArray(targets)){
      targets_str = targets.join(',');
    }else if (typeof targets === 'string' || targets instanceof String){
      targets_str = targets;
    }else{
      targets_str = "";
    }

    $.ajax({
      type: "POST",
      url: '/api/cmd',
      data: {
          master:  appData.master,
          targets: targets_str,
          cmd:     cmd
      },
      dataType: "xml",
      success: callback
    });

    return 0;
}

function update_slave_list(name){
  appData.slaves.push(name);
  appData.slaves_selected.push(name);
}

function update_ip_list(ip){
  appData.ips.push(ip);
}

function update_master_node(newvalue){

  if (newvalue!==undefined){
    appData.master = newvalue;
    appData.slaves = [];
  }

  $("#masternode").html(appData.master);

}

function get_ipaddr_from_ifconfig(str){

  // for Elphel 10393
  const iface_regex_10393  = /[^\ \n]+(?=\ +Link\ encap)/gi;
  const ipaddr_regex_10393 = /(?<=inet\ addr\:)\d+\.\d+\.\d+\.\d+/gi;
  // for PC
  const iface_regex_pc     = /[^\ \n]+(?=\:\ flags)/gi;
  const ipaddr_regex_pc    = /(?<=inet\ )\d+\.\d+\.\d+\.\d+/gi;

  let res = "";

  let ifaces  = str.match(iface_regex_10393);
  let ipaddrs = str.match(ipaddr_regex_10393);

  if (ifaces===null || ipaddrs===null){
    ifaces  = str.match(iface_regex_pc);
    ipaddrs = str.match(ipaddr_regex_pc);
  }

  for(var i=0;i<ipaddrs.length;i++){
    if (ifaces[i]!=='lo') {
      res = ipaddrs[i];
    }
    break;
  }

  return res;

}







